Status: Closed Start date: 05 Jul 2013

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: Incomplete function Estimated time: 2.50 hours

Target version: CoCoA-5.1.0 Easter14 Spent time: 3.50 hours

Description

The built-in fn IsZero works for many types (INT, RAT, RINGELEM, MODULEELEM and IDEAL).

Should it work for matrices (type MAT) too?

However I do not think it should be applicable to LIST.

Related issues:

Related to CoCoA-5 - Design #525: BuiltInFunctions: evalArgAsT1OrT2, evalArgA... Closed 08 Apr 2014

History

#1 - 02 Apr 2014 09:49 - Anna Maria Bigatti

- Category set to Incomplete function

- Target version set to CoCoA-5.1.0 Easter14

I think we should have IsZero for MAT

#2 - 13 Apr 2014 21:05 - Anna Maria Bigatti

- Status changed from New to In Progress

- % Done changed from 0 to 10

I tried implementing it in a clever way but got stuck.

(clever = ZeroImpl gives true, IdentityImpl gives false, ...)

But I had a brilliant(?) idea: should we just implement IsZero as return M = ZeroMat(R, NR, NC) and let the equality test to be clever?  (I think it is

clever)

#3 - 14 Apr 2014 08:42 - Anna Maria Bigatti

- Assignee set to Anna Maria Bigatti

- % Done changed from 10 to 50

- Estimated time set to 2.50 h

Implemented as described above.

Seems to work (added test IsZero(ZeroMat(R, 12345,67890)) and is fast).

But where should the implementation go?  matrix.C or MatrixViews.C?

Now the prototype is in matrix.H and the implementation in MatrixViews.C...

#4 - 14 Apr 2014 08:59 - Anna Maria Bigatti

Added to cocoa-5

I had to add evalArgAsT1orT2orT3orT4orT5orT6orT7 in Interpreter.H.
#5 - 14 Apr 2014 10:39 - John Abbott

JAA suggests putting it in MatrixOperations

#6 - 14 Apr 2014 10:56 - Anna Maria Bigatti

John Abbott wrote:

JAA suggests putting it in MatrixOperations

 

OK.  Should we also move IsZeroRow/Col?

#7 - 14 Apr 2014 16:32 - Anna Maria Bigatti

- % Done changed from 50 to 80

JAA suggests putting it in MatrixOperations

 

(after talking about it on the phone) moved all Is.. functions from matrix.C to MatrixOperation.

#8 - 17 Apr 2014 18:57 - John Abbott

- Status changed from In Progress to Feedback

- % Done changed from 80 to 90

#9 - 07 May 2014 14:01 - John Abbott

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

Implemented, documented, tested.

Closing..
